
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Sales_order_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sales_order_lines = await db.sales_order_lines.create(
            {
                id: data.id || undefined,
        
        line_number: data.line_number
        ||
        null
            ,
            
        ordered_quantity: data.ordered_quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        discount_percent: data.discount_percent
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
        need_by_at: data.need_by_at
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await sales_order_lines.setSales_order( data.sales_order || null, {
            transaction,
        });
        
        await sales_order_lines.setItem( data.item || null, {
            transaction,
        });
        
        await sales_order_lines.setUom( data.uom || null, {
            transaction,
        });
        

        

        

        return sales_order_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const sales_order_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                line_number: item.line_number
            ||
            null
            ,
            
                ordered_quantity: item.ordered_quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                discount_percent: item.discount_percent
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
                need_by_at: item.need_by_at
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const sales_order_lines = await db.sales_order_lines.bulkCreate(sales_order_linesData, { transaction });

        // For each item created, replace relation files
        

        return sales_order_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const sales_order_lines = await db.sales_order_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.line_number !== undefined) updatePayload.line_number = data.line_number;
        
        
        if (data.ordered_quantity !== undefined) updatePayload.ordered_quantity = data.ordered_quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.discount_percent !== undefined) updatePayload.discount_percent = data.discount_percent;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        if (data.need_by_at !== undefined) updatePayload.need_by_at = data.need_by_at;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await sales_order_lines.update(updatePayload, {transaction});

        
        
        if (data.sales_order !== undefined) {
            await sales_order_lines.setSales_order(
              
              data.sales_order,
              
              { transaction }
            );
        }
        
        if (data.item !== undefined) {
            await sales_order_lines.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.uom !== undefined) {
            await sales_order_lines.setUom(
              
              data.uom,
              
              { transaction }
            );
        }
        

        
        

        

        return sales_order_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const sales_order_lines = await db.sales_order_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of sales_order_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of sales_order_lines) {
                await record.destroy({transaction});
            }
        });


        return sales_order_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const sales_order_lines = await db.sales_order_lines.findByPk(id, options);

        await sales_order_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await sales_order_lines.destroy({
            transaction
        });

        return sales_order_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const sales_order_lines = await db.sales_order_lines.findOne(
            { where },
            { transaction },
        );

        if (!sales_order_lines) {
            return sales_order_lines;
        }

        const output = sales_order_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.sales_order = await sales_order_lines.getSales_order({
            transaction
        });
        
        
        output.item = await sales_order_lines.getItem({
            transaction
        });
        
        
        output.uom = await sales_order_lines.getUom({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.sales_orders,
        as: 'sales_order',
        
        where: filter.sales_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sales_order.split('|').map(term => Utils.uuid(term)) } },
            {
              so_number: {
                [Op.or]: filter.sales_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.uoms,
        as: 'uom',
        
        where: filter.uom ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uom.split('|').map(term => Utils.uuid(term)) } },
            {
              code: {
                [Op.or]: filter.uom.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'sales_order_lines',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.line_numberRange) {
                const [start, end] = filter.line_numberRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_number: {
                    ...where.line_number,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_number: {
                    ...where.line_number,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ordered_quantityRange) {
                const [start, end] = filter.ordered_quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ordered_quantity: {
                    ...where.ordered_quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ordered_quantity: {
                    ...where.ordered_quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_percentRange) {
                const [start, end] = filter.discount_percentRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_percent: {
                    ...where.discount_percent,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_percent: {
                    ...where.discount_percent,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.need_by_atRange) {
                const [start, end] = filter.need_by_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    need_by_at: {
                    ...where.need_by_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    need_by_at: {
                    ...where.need_by_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.sales_order_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'sales_order_lines',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.sales_order_lines.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

